diff --git a/game/core/src/main/java/net/minecraft/core/achievement/stat/StatsSyncher.java b/game/core/src/main/java/net/minecraft/core/achievement/stat/StatsSyncher.java
index fee7b6d4c..bc3bc166d 100644
--- a/game/core/src/main/java/net/minecraft/core/achievement/stat/StatsSyncher.java
+++ b/game/core/src/main/java/net/minecraft/core/achievement/stat/StatsSyncher.java
@@ -2,17 +2,17 @@ package net.minecraft.core.achievement.stat;
 
 import com.b100.utils.StringUtils;
 import com.mojang.logging.LogUtils;
+import it.unimi.dsi.fastutil.objects.Object2IntMap;
 import net.minecraft.core.player.Session;
 import org.slf4j.Logger;
 
 import java.io.*;
-import java.util.Map;
 
 public class StatsSyncher {
     private static final Logger LOGGER = LogUtils.getLogger();
     private volatile boolean busy = false;
-    private volatile Map<Stat, Integer> queuedLocalStatsChanges;
-    private volatile Map<Stat, Integer> queuedSavedStatsChanges;
+    private volatile Object2IntMap<Stat> queuedLocalStatsChanges;
+    private volatile Object2IntMap<Stat> queuedSavedStatsChanges;
     private final StatsCounter statsCounter;
     private final File unsentStatsFile;
     private final File statsFile;
@@ -24,43 +24,43 @@ public class StatsSyncher {
     private int saveTimer;
     private int fetchChangesTimer; // I'm making a sorta longshot guess, but I think this is the remnant of an unused timer to retrieve stat changes from the server
 
-    public StatsSyncher(Session session, StatsCounter statsCounter, File statsDir) {
-        queuedLocalStatsChanges = null;
-        queuedSavedStatsChanges = null;
-        saveTimer = 0;
-        fetchChangesTimer = 0;
+    public StatsSyncher(final Session session, final StatsCounter statsCounter, final File statsDir) {
+        this.queuedLocalStatsChanges = null;
+        this.queuedSavedStatsChanges = null;
+        this.saveTimer = 0;
+        this.fetchChangesTimer = 0;
 
-        statsFile =           (new File(statsDir, "stats_" + session.uuid + ".dat"));
-        statsFileOld =        (new File(statsDir, "stats_" + session.uuid + ".old"));
-        statsFileTemp =       (new File(statsDir, "stats_" + session.uuid + ".tmp"));
-        unsentStatsFile =     (new File(statsDir, "stats_" + session.uuid + "_unsent.dat"));
-        unsentStatsFileOld =  (new File(statsDir, "stats_" + session.uuid + "_unsent.old"));
-        unsentStatsFileTemp = (new File(statsDir, "stats_" + session.uuid + "_unsent.tmp"));
+        this.statsFile =           (new File(statsDir, "stats_" + session.uuid + ".dat"));
+        this.statsFileOld =        (new File(statsDir, "stats_" + session.uuid + ".old"));
+        this.statsFileTemp =       (new File(statsDir, "stats_" + session.uuid + ".tmp"));
+        this.unsentStatsFile =     (new File(statsDir, "stats_" + session.uuid + "_unsent.dat"));
+        this.unsentStatsFileOld =  (new File(statsDir, "stats_" + session.uuid + "_unsent.old"));
+        this.unsentStatsFileTemp = (new File(statsDir, "stats_" + session.uuid + "_unsent.tmp"));
 
         // Remap pre-UUID stats to new UUID files
-        new File(statsDir, "stats_" + session.username.toLowerCase() + ".dat").renameTo(statsFile);
-        new File(statsDir, "stats_" + session.username.toLowerCase() + ".old").renameTo(statsFileOld);
-        new File(statsDir, "stats_" + session.username.toLowerCase() + ".tmp").renameTo(statsFileTemp);
-        new File(statsDir, "stats_" + session.username.toLowerCase() + "_unsent.dat").renameTo(unsentStatsFile);
-        new File(statsDir, "stats_" + session.username.toLowerCase() + "_unsent.old").renameTo(unsentStatsFileOld);
-        new File(statsDir, "stats_" + session.username.toLowerCase() + "_unsent.tmp").renameTo(unsentStatsFileTemp);
+        new File(statsDir, "stats_" + session.username.toLowerCase() + ".dat").renameTo(this.statsFile);
+        new File(statsDir, "stats_" + session.username.toLowerCase() + ".old").renameTo(this.statsFileOld);
+        new File(statsDir, "stats_" + session.username.toLowerCase() + ".tmp").renameTo(this.statsFileTemp);
+        new File(statsDir, "stats_" + session.username.toLowerCase() + "_unsent.dat").renameTo(this.unsentStatsFile);
+        new File(statsDir, "stats_" + session.username.toLowerCase() + "_unsent.old").renameTo(this.unsentStatsFileOld);
+        new File(statsDir, "stats_" + session.username.toLowerCase() + "_unsent.tmp").renameTo(this.unsentStatsFileTemp);
 
         this.statsCounter = statsCounter;
         this.session = session;
-        if (unsentStatsFile.exists()) {
-            statsCounter.addToBoth(readStatsFromFile(unsentStatsFile, unsentStatsFileTemp, unsentStatsFileOld));
+        if (this.unsentStatsFile.exists()) {
+            statsCounter.addToBoth(readStatsFromFile(this.unsentStatsFile, this.unsentStatsFileTemp, this.unsentStatsFileOld));
         }
         startRetrievalThread();
     }
 
-    private void renameFile(File parent, String child, File fileToRename) {
-        File destFile = new File(parent, child);
+    private void renameFile(final File parent, final String child, final File fileToRename) {
+        final File destFile = new File(parent, child);
         if (destFile.exists() && !destFile.isDirectory() && !fileToRename.exists()) {
             destFile.renameTo(fileToRename);
         }
     }
 
-    private Map<Stat, Integer> readStatsFromFile(File statsFile, File tempStatsFile, File oldStatsFile) {
+    private Object2IntMap<Stat> readStatsFromFile(final File statsFile, final File tempStatsFile, final File oldStatsFile) {
         if (statsFile.exists()) {
             return readStatsFromFile(statsFile);
         }
@@ -74,19 +74,19 @@ public class StatsSyncher {
         }
     }
 
-    private Map<Stat, Integer> readStatsFromFile(File statsFile) {
+    private Object2IntMap<Stat> readStatsFromFile(final File statsFile) {
         try {
             return StatsCounter.readStatsFromString(StringUtils.getFileContentAsString(statsFile));
-        } catch (Exception e) {
+        } catch (final Exception e) {
             LOGGER.warn("Failed to read stats from file '{}'!", statsFile.getPath(), e);
         }
         return null;
     }
 
-    private void saveStats(Map<Stat, Integer> map, File statsFile, File tempStatsFile, File oldStatsFile)
+    private void saveStats(final Object2IntMap<Stat> map, final File statsFile, final File tempStatsFile, final File oldStatsFile)
         throws IOException {
-        try (PrintWriter writer = new PrintWriter(new FileWriter(tempStatsFile, false))) {
-            writer.print(StatsCounter.getStatFileContentString(session.uuid, "local", map));
+        try (final PrintWriter writer = new PrintWriter(new FileWriter(tempStatsFile, false))) {
+            writer.print(StatsCounter.getStatFileContentString(this.session.uuid, "local", map));
         }
         if (oldStatsFile.exists()) {
             oldStatsFile.delete();
@@ -98,83 +98,83 @@ public class StatsSyncher {
     }
 
     public void startRetrievalThread() {
-        if (busy) {
+        if (this.busy) {
             throw new IllegalStateException("Can't get stats from server while StatsSyncher is busy!");
         } else {
-            saveTimer = 100;
-            busy = true;
+            this.saveTimer = 100;
+            this.busy = true;
             new Thread(() -> {
                 try {
-                    if (queuedLocalStatsChanges != null) {
-                        saveStats(queuedLocalStatsChanges, statsFile, statsFileTemp, statsFileOld);
-                    } else if (statsFile.exists()) {
-                        queuedLocalStatsChanges = readStatsFromFile(statsFile, statsFileTemp, statsFileOld);
+                    if (this.queuedLocalStatsChanges != null) {
+                        saveStats(this.queuedLocalStatsChanges, this.statsFile, this.statsFileTemp, this.statsFileOld);
+                    } else if (this.statsFile.exists()) {
+                        this.queuedLocalStatsChanges = readStatsFromFile(this.statsFile, this.statsFileTemp, this.statsFileOld);
                     }
-                } catch (Exception exception) {
+                } catch (final Exception exception) {
                     LOGGER.error("Unexpected exception in retrieval thread!", exception);
                 } finally {
-                    busy = false;
+                    this.busy = false;
                 }
             }).start();
         }
     }
 
-    public void startSavingThread(Map<Stat, Integer> mapToSave) {
-        if (busy) {
+    public void startSavingThread(final Object2IntMap<Stat> mapToSave) {
+        if (this.busy) {
             throw new IllegalStateException("Can't save stats while StatsSyncher is busy!");
         } else {
-            saveTimer = 100;
-            busy = true;
+            this.saveTimer = 100;
+            this.busy = true;
             new Thread(() -> {
                 try {
-                    saveStats(mapToSave, unsentStatsFile, unsentStatsFileTemp, unsentStatsFileOld);
-                } catch (Exception exception) {
+                    saveStats(mapToSave, this.unsentStatsFile, this.unsentStatsFileTemp, this.unsentStatsFileOld);
+                } catch (final Exception exception) {
                     LOGGER.error("Unexpected exception in saving thread!", exception);
                 } finally {
-                    busy = false;
+                    this.busy = false;
                 }
 
             }).start();
         }
     }
 
-    public void saveStatsToDisk(Map<Stat, Integer> map) {
-        for (int i = 30; busy && --i > 0; ) {
+    public void saveStatsToDisk(final Object2IntMap<Stat> map) {
+        for (int i = 30; this.busy && --i > 0; ) {
             try {
                 Thread.sleep(100L);
-            } catch (InterruptedException interrupt) {
+            } catch (final InterruptedException interrupt) {
                 LOGGER.warn("Interrupted!", interrupt);
             }
         }
 
-        busy = true;
+        this.busy = true;
         try {
-            saveStats(map, unsentStatsFile, unsentStatsFileTemp, unsentStatsFileOld);
-        } catch (Exception exception) {
+            saveStats(map, this.unsentStatsFile, this.unsentStatsFileTemp, this.unsentStatsFileOld);
+        } catch (final Exception exception) {
             LOGGER.error("Exception saving stats!", exception);
         } finally {
-            busy = false;
+            this.busy = false;
         }
     }
 
     public boolean pendingSave() {
-        return saveTimer <= 0 && !busy && queuedSavedStatsChanges == null;
+        return this.saveTimer <= 0 && !this.busy && this.queuedSavedStatsChanges == null;
     }
 
     public void tick() {
-        if (saveTimer > 0) {
-            saveTimer--;
+        if (this.saveTimer > 0) {
+            this.saveTimer--;
         }
-        if (fetchChangesTimer > 0) {
-            fetchChangesTimer--;
+        if (this.fetchChangesTimer > 0) {
+            this.fetchChangesTimer--;
         }
-        if (queuedSavedStatsChanges != null) {
-            statsCounter.addToSaved(queuedSavedStatsChanges);
-            queuedSavedStatsChanges = null;
+        if (this.queuedSavedStatsChanges != null) {
+            this.statsCounter.addToSaved(this.queuedSavedStatsChanges);
+            this.queuedSavedStatsChanges = null;
         }
-        if (queuedLocalStatsChanges != null) {
-            statsCounter.addToLocal(queuedLocalStatsChanges);
-            queuedLocalStatsChanges = null;
+        if (this.queuedLocalStatsChanges != null) {
+            this.statsCounter.addToLocal(this.queuedLocalStatsChanges);
+            this.queuedLocalStatsChanges = null;
         }
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicMoss.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicMoss.java
index 9787d6a11..9e19c4a8f 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicMoss.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicMoss.java
@@ -1,5 +1,6 @@
 package net.minecraft.core.block;
 
+import it.unimi.dsi.fastutil.ints.Int2IntArrayMap;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.item.IBonemealable;
 import net.minecraft.core.item.ItemStack;
@@ -15,7 +16,7 @@ import java.util.Map.Entry;
 import java.util.Random;
 
 public class BlockLogicMoss extends BlockLogic implements IBonemealable {
-	public static WorldFeatureOre.OreMap variantMap = new WorldFeatureOre.OreMap();
+	public static Int2IntArrayMap variantMap = new Int2IntArrayMap();
 	public BlockLogicMoss(Block<?> block, Block<?> parentBlock) {
 		super(block, Material.moss);
 		block.setTicking(true);
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicNote.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicNote.java
index 858749eee..7b023a62c 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicNote.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicNote.java
@@ -1,6 +1,8 @@
 package net.minecraft.core.block;
 
 import com.mojang.logging.LogUtils;
+import it.unimi.dsi.fastutil.ints.Int2ObjectArrayMap;
+import it.unimi.dsi.fastutil.ints.Int2ObjectMap;
 import net.minecraft.core.block.entity.TileEntityActivator;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.sound.SoundCategory;
@@ -109,7 +111,7 @@ public class BlockLogicNote extends BlockLogic
     }
 
     public static class Instrument {
-        public static final Map<Integer, Instrument> instrumentMap = new HashMap<>();
+        public static final Int2ObjectMap<Instrument> instrumentMap = new Int2ObjectArrayMap<>();
         public final int index;
         public final String soundKey;
 
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicOreCoal.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicOreCoal.java
index 7b638b37e..284823833 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicOreCoal.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicOreCoal.java
@@ -1,5 +1,6 @@
 package net.minecraft.core.block;
 
+import it.unimi.dsi.fastutil.ints.Int2IntArrayMap;
 import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.Items;
@@ -13,7 +14,7 @@ import java.util.Map;
 
 public class BlockLogicOreCoal extends BlockLogic
 {
-    public static WorldFeatureOre.OreMap variantMap = new WorldFeatureOre.OreMap();
+    public static Int2IntArrayMap variantMap = new Int2IntArrayMap();
 
     public BlockLogicOreCoal(Block<?> block, Block<?> parentBlock, Material material){
         super(block, material);
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicOreDiamond.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicOreDiamond.java
index e25b350f6..41c78b98b 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicOreDiamond.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicOreDiamond.java
@@ -1,5 +1,6 @@
 package net.minecraft.core.block;
 
+import it.unimi.dsi.fastutil.ints.Int2IntArrayMap;
 import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.Items;
@@ -13,7 +14,7 @@ import java.util.Map;
 
 public class BlockLogicOreDiamond extends BlockLogic
 {
-    public static WorldFeatureOre.OreMap variantMap = new WorldFeatureOre.OreMap();
+    public static Int2IntArrayMap variantMap = new Int2IntArrayMap();
     public BlockLogicOreDiamond(Block<?> block, Block<?> parentBlock, Material material)
     {
         super(block, material);
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicOreGold.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicOreGold.java
index 2bb4211df..1e768cbe6 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicOreGold.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicOreGold.java
@@ -1,5 +1,6 @@
 package net.minecraft.core.block;
 
+import it.unimi.dsi.fastutil.ints.Int2IntArrayMap;
 import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.Items;
@@ -13,7 +14,7 @@ import java.util.Map;
 
 
 public class BlockLogicOreGold extends BlockLogic {
-    public static WorldFeatureOre.OreMap variantMap = new WorldFeatureOre.OreMap();
+    public static Int2IntArrayMap variantMap = new Int2IntArrayMap();
 
     public BlockLogicOreGold(Block<?> block, Block<?> parentBlock, Material material) {
         super(block, material);
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicOreIron.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicOreIron.java
index 80a828668..af197ca1e 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicOreIron.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicOreIron.java
@@ -1,5 +1,6 @@
 package net.minecraft.core.block;
 
+import it.unimi.dsi.fastutil.ints.Int2IntArrayMap;
 import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.Items;
@@ -13,7 +14,7 @@ import java.util.Map;
 
 public class BlockLogicOreIron extends BlockLogic
 {
-    public static WorldFeatureOre.OreMap variantMap = new WorldFeatureOre.OreMap();
+    public static Int2IntArrayMap variantMap = new Int2IntArrayMap();
     public BlockLogicOreIron(Block<?> block, Block<?> parentBlock, Material material) {
         super(block, material);
         variantMap.put(parentBlock.id(), block.id());
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicOreLapis.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicOreLapis.java
index 228954fe8..e70f5f4d3 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicOreLapis.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicOreLapis.java
@@ -1,5 +1,6 @@
 package net.minecraft.core.block;
 
+import it.unimi.dsi.fastutil.ints.Int2IntArrayMap;
 import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.Items;
@@ -14,7 +15,7 @@ import java.util.Map;
 
 public class BlockLogicOreLapis extends BlockLogic
 {
-    public static WorldFeatureOre.OreMap variantMap = new WorldFeatureOre.OreMap();
+    public static Int2IntArrayMap variantMap = new Int2IntArrayMap();
     public BlockLogicOreLapis(Block<?> block, Block<?> parentBlock, Material material)
     {
         super(block, material);
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicOreRedstone.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicOreRedstone.java
index e5057d4bf..bee8f2431 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicOreRedstone.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicOreRedstone.java
@@ -1,5 +1,6 @@
 package net.minecraft.core.block;
 
+import it.unimi.dsi.fastutil.ints.Int2IntArrayMap;
 import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.block.entity.TileEntityActivator;
 import net.minecraft.core.entity.Entity;
@@ -18,7 +19,7 @@ import java.util.Random;
 
 public class BlockLogicOreRedstone extends BlockLogic
 {
-    public static WorldFeatureOre.OreMap variantMap = new WorldFeatureOre.OreMap();
+    public static Int2IntArrayMap variantMap = new Int2IntArrayMap();
     private final boolean illuminated;
     private final Block<?> normalBlock;
     private final Block<?> illuminatedBlock;
diff --git a/game/core/src/main/java/net/minecraft/core/block/Blocks.java b/game/core/src/main/java/net/minecraft/core/block/Blocks.java
index db6111b82..244fc868f 100644
--- a/game/core/src/main/java/net/minecraft/core/block/Blocks.java
+++ b/game/core/src/main/java/net/minecraft/core/block/Blocks.java
@@ -1,5 +1,7 @@
 package net.minecraft.core.block;
 
+import it.unimi.dsi.fastutil.objects.Object2IntMap;
+import it.unimi.dsi.fastutil.objects.Object2IntOpenHashMap;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.block.material.MaterialColor;
 import net.minecraft.core.block.piston.BlockLogicPistonBase;
@@ -36,7 +38,7 @@ import java.util.Map;
 public final class Blocks {
     public static final @Nullable Block<?> @NotNull [] blocksList = new Block<?>[16384];
     public static final Map<NamespaceID, Block<?>> blockMap = new LinkedHashMap<>();
-    @Deprecated public static final Map<String, Integer> keyToIdMap = new HashMap<>();
+    @Deprecated public static final Object2IntMap<String> keyToIdMap = new Object2IntOpenHashMap<>();
     public static final boolean[] shouldTick = new boolean[blocksList.length];
     public static final boolean[] solid = new boolean[blocksList.length];
     public static final boolean[] isEntityTile = new boolean[blocksList.length];
@@ -1289,7 +1291,7 @@ public final class Blocks {
 
         if (Blocks.blocksList[container.id()] != null) throw new IllegalArgumentException("Id '" + id + "' of block '" + container.namespaceId() + "' is already being used by '" + Blocks.blocksList[container.id()].namespaceId() + "'!");
         Blocks.blocksList[container.id()] = container;
-        if (Blocks.keyToIdMap.containsKey(container.getKey())) throw new IllegalArgumentException("Key '" + container.getKey() + "' of block '" + container.namespaceId() + "' is already being used by '" + Blocks.getBlock(Blocks.keyToIdMap.get(container.getKey())).namespaceId() + "'!");
+        if (Blocks.keyToIdMap.containsKey(container.getKey())) throw new IllegalArgumentException("Key '" + container.getKey() + "' of block '" + container.namespaceId() + "' is already being used by '" + Blocks.getBlock(Blocks.keyToIdMap.getInt(container.getKey())).namespaceId() + "'!");
         Blocks.keyToIdMap.put(container.getKey(), container.id());
         if (Blocks.blockMap.containsKey(container.namespaceId())) throw new IllegalArgumentException("NamespaceId '" + container.namespaceId() + "' of block '" + container.getKey() + "' is already being used by '" + Blocks.blockMap.get(container.namespaceId()).namespaceId() + "'!");
         Blocks.blockMap.put(container.namespaceId(), container);
